﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
#DesignerProperty: Key: ShowPathEntryKey, 	DisplayName: Show Path Entry,  	FieldType: Boolean, 	DefaultValue: True, 		Description: Show Path Field Entry 
#DesignerProperty: Key: BorderColorKey,    	DisplayName: Pnl Border Color,	FieldType: Color, 		DefaultValue: 0xFFA39F9F, 	Description: Border Color
#DesignerProperty: Key: BackColorKey,    	DisplayName: Back Color, 	  	FieldType: Color, 		DefaultValue: #FFFFFFFF, 	Description: Panel Back Color
#DesignerProperty: Key: BorderWidthKey,    	DisplayName: Border Width, 	  	FieldType: Int,		 	DefaultValue: 1,	 		Description: Border Width
#DesignerProperty: Key: BorderRadiusKey,   	DisplayName: Border Radius,		FieldType: Int, 		DefaultValue: 4,			Description: Border Radius
#DesignerProperty: Key: TextColorKey,    	DisplayName: Text Color, 	  	FieldType: Color, 		DefaultValue: 0xFFFFFFFF, 	Description: Text Color
#DesignerProperty: Key: TextBackColorKey,   DisplayName: Text Back Color, 	FieldType: Color, 		DefaultValue: #FFFFFFFF, 	Description: Text Back Color

#Event: FileSelected (fAttr As FileAttr_t)
#RaisesSynchronousEvents: FileSelected 

#Event: DirSelected (dir As String)
#RaisesSynchronousEvents: DirSelected 

'fileEntry Class V1.1 Fixed minor errors and added checkpointing to database before backing it up on a delete
'rjg 15/9/2020

Sub Class_Globals
	Type FileAttr_t(fileName As String, path As String, size As Long, creationDate As Long, LastModifiedTime As Long, LastAccessTime As Long, readOnly As Boolean, _
					system As Boolean, hidden As Boolean, archived As Boolean, FilePermissions As Map, FileNotFound As Char, FileExt As String)
	Type FileDateStr_t(creationDate As String, LastModifiedTime As String, LastAccessTime As String)

	Type mainTableProduceColumn_t( _
									col_ID 				As B4XTableColumn, _
									col_fileName 		As B4XTableColumn, _
									col_pathName 		As B4XTableColumn, _
									col_ext				As B4XTableColumn, _
									dateLastAccessed 	As B4XTableColumn, _
									dateCreated 		As B4XTableColumn, _
									dateLastModified 	As B4XTableColumn, _
									fileSize 			As B4XTableColumn, _
									readOnly 			As B4XTableColumn, _
									hidden 				As B4XTableColumn, _		
									system 				As B4XTableColumn, _
									archive 			As B4XTableColumn)
									
	
	Private fx As JFX
	Private mEventName As String
	Private mCallBack As Object
	Public  mBase As B4XView
	Private xui As XUI
	Private Toast As clXToastMessage
		
	Public Tag As Object
	Private btnCpypath As B4XView
	Private btnRecent As B4XView
	Private btnFileNameCpy As B4XView

	Private displayMode As Int	'0 = File Only, 1 = File and Path, 2 = file and recent, 3 = file and path and recent
	'Bit 0 > Show Path, Bit 1 > Show Recent
	
	Private fAttr As FileAttr_t
	Private fAttrDatesAsStrings As FileDateStr_t
	
	Private fileNameSel As String
	Private pathNameSel As String
	
	Private fileNameUndo As String
	Private pathNameUndo As String
	
	Private btnGetFileName As B4XView
	Private callingForm As Form

	Private textFilename As B4XView
	Private textPath As B4XView
	Private timerDblClick As Timer
	Private timerDblClickFlag As Boolean
	
	Private dataDir As String
	Private dbRecentFilename As String
	Private sqlRecent As SQL
	Private recentOK As Boolean
	
	Public showPathEntry As Boolean
	Public BorderWidth, BorderRadius As Double
	
	Public initPanelHeight As Int
	Public initPanelWidth As Int

	Private Pane1 As B4XView
	Private btnPathExpose As B4XView
	Private btnGetFolder As B4XView
	
	Private enableFileSelEvent As Boolean
	Private enableDirSelEvent As Boolean
	Private b4xTableRecent As B4XTable
	Private chkBoxShowAll As B4XView
	Private comboFileTypeExt As B4XComboBox
	Private btnExportRecentList As B4XView
	Private exportToSqLite As B4XView
	Private btnClearRecentList As B4XView
End Sub


'======================================================================================================
Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	fAttr.Initialize
	fAttrDatesAsStrings.Initialize
	
	timerDblClick.Initialize("timerDblClick", 300)
	
	dbRecentFilename = "RecentFilesDB.db"
	dataDir = makeDataDirUnderAppDir("Files")
'	recentOK = initRecentDatabase(dataDir, dbRecentFilename)
End Sub


'======================================================================================================
'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	mBase.Tag = Me

	Toast.Initialize(mBase)
	Toast.SetTMDefaults
	
	mBase.LoadLayout("fileGetLayout.bjl")
	Sleep(0)
	
	showPathEntry = Props.GetDefault("ShowPathEntryKey", True)
	
	initPanelHeight = Pane1.Height
	initPanelWidth  = Pane1.Width

	displayControl
	b4xTableRecent.mBase.Visible = False

	Dim col As Int = xui.PaintOrColorToColor(Props.GetDefault("BorderColorKey", fx.Colors.From32Bit(0xFFA39F9F)))
	Dim borderCol As Paint = fx.Colors.From32bit(col)

	CSSUtils.SetBackgroundColor(Pane1, fx.Colors.From32bit(Props.GetDefault("BackColorPaneKey", 0xFFFFFFFF)))
	CSSUtils.SetBorder(Pane1, _
					   Props.GetDefault("BorderWidthKey", 1.0), _
					   borderCol, _
					   Props.GetDefault("BorderRadius", 2.0))

	' Add keyboard handlers for the text fields
	Dim r As Reflector
	r.Target = textFilename
	r.AddEventFilter("textFilename", "javafx.scene.input.KeyEvent.KEY_RELEASED")
	
	r.Target = textPath
	r.AddEventFilter("textPath", "javafx.scene.input.KeyEvent.KEY_RELEASED")
	
	r.Target = btnRecent
	r.AddEventFilter("btnRecent", "javafx.scene.input.KeyEvent.KEY_RELEASED")

	r.Target = btnGetFileName
	r.AddEventFilter("btnGetFileName", "javafx.scene.input.KeyEvent.KEY_RELEASED")
	
	r.Target = btnGetFolder
	r.AddEventFilter("btnGetFolder", "javafx.scene.input.KeyEvent.KEY_RELEASED")
	
	r.Target = btnCpypath
	r.AddEventFilter("btnCpypath", "javafx.scene.input.KeyEvent.KEY_RELEASED")
	
	r.Target = btnFileNameCpy
	r.AddEventFilter("btnFileNameCpy", "javafx.scene.input.KeyEvent.KEY_RELEASED")

	chkBoxShowAll.Checked = True
	comboFileTypeExt.mBase.Enabled = False
	
	recentOK = initRecentDatabase(dataDir, dbRecentFilename)

	If recentOK Then  initRecentFilesTable
	
	'If the recent files database is initialized OK then show the recent files button
	btnRecent.Visible = recentOK
	btnRecent.Enabled = recentOK
End Sub


'======================================================================================================
Public Sub makeDataDirUnderAppDir(dirName As String) As String
	'Get the App dir and check If this is the Objects directory - We don't want to put user files in here
	Dim cwd As String = File.DirApp

	Dim matcher1 As Matcher = Regex.Matcher("[^\\]+\\?$",cwd)
	
	Do While matcher1.Find
		If matcher1.Match.ToLowerCase.CompareTo("objects") = 0 Then
			cwd = Regex.Replace("[^\\]+\\?$", File.DirApp, "\Files")
			Exit
		End If
	Loop
	
	'Check if new cwd Exists and create if neccessary
	If File.IsDirectory (cwd,"") = False Then
		File.MakeDir(cwd, "Files")
	End If
	
	Return cwd
End Sub


'======================================================================================================
public Sub setEnableFileEvent(enArg As Boolean)
	enableFileSelEvent = enArg
End Sub


'======================================================================================================
public Sub getEnableFileEvent As Boolean
	Return enableFileSelEvent
End Sub


'======================================================================================================
public Sub setEnableDirEvent(enArg As Boolean)
	enableDirSelEvent = enArg
End Sub


'======================================================================================================
public Sub getEnableDirEvent As Boolean
	Return enableDirSelEvent
End Sub

'======================================================================================================
Public Sub getDataPath As String
	Return dataDir
End Sub


'======================================================================================================
Public Sub getUserPath As String
	Return GetSystemProperty("user.dir", dataDir)
End Sub


'======================================================================================================
public Sub InitCallingForm(callForm As Form)
	callingForm 		= callForm
End Sub


'======================================================================================================
Public Sub getFilePath As String
	Return pathNameSel
End Sub


'======================================================================================================
Public Sub getFileName As String
	Return fileNameSel
End Sub

'======================================================================================================
public Sub InitPathAndFileName(pathNameInit As String, filenameInit As String, callForm As Form, displayModeArg As Int)
	callingForm 		= callForm
	fileNameSel			= filenameInit
	pathNameSel 		= pathNameInit
	fileNameUndo		= filenameInit
	pathNameUndo 		= pathNameInit
'	textFilename.Text 	= fileNameSel
'	textPath.Text 	  	= pathNameSel
	displayMode 		= displayModeArg
End Sub


'======================================================================================================
Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub


'======================================================================================================
private Sub timerDblClick_tick
	timerDblClick.Enabled = False
	timerDblClickFlag = False
End Sub


'======================================================================================================
private Sub concatPathFilename(pathArg As String, fileNameArg As String) As String
	
	If pathArg.EndsWith("\") Then
		Return pathArg & fileNameArg
	Else
		Return pathArg & "\" & fileNameArg
	End If
End Sub


'======================================================================================================
private Sub btnFileNameCpy_Click
	If timerDblClickFlag = False Then
		timerDblClick.Enabled = True
		timerDblClickFlag = True
		fx.Clipboard.SetString(fileNameSel)
	Else
		timerDblClick.Enabled = False
		timerDblClickFlag = False
		fx.Clipboard.SetString(concatPathFilename(pathNameSel,fileNameSel))
	End If
	Log(fx.Clipboard.GetString)
End Sub


'======================================================================================================
private Sub btnCpypath_Click
	If timerDblClickFlag = False Then
		timerDblClick.Enabled = True
		timerDblClickFlag = True
		fx.Clipboard.SetString(pathNameSel)
	Else
		timerDblClick.Enabled = False
		timerDblClickFlag = False
		fx.Clipboard.SetString(concatPathFilename(pathNameSel,fileNameSel))
	End If
	Log(fx.Clipboard.GetString)
End Sub


'======================================================================================================
private Sub btnGetFileName_Click

	Dim fc As FileChooser
	fc.Initialize
	fileNameUndo = fileNameSel
	fc.InitialDirectory = pathNameSel
	fc.InitialFileName  = fileNameSel
	
	Dim fw As FileWatcher
	fw.Initialize("")

	AddExtensionFilters4(fc, Array As String("uVision5.map ", "uVision5.*"), _
							 Array As String("*.map", "*.*"), _
							 True,"Keil uVision 5 Map Files", True)
	
	SetSelectedExtensionFilter(fc,"Keil uVision 5 Map Files")
	
	fc.Title = "Keil uVision 5 Map Files Open"
	Dim f As String = fc.ShowOpen(callingForm)

	FileAttributes(f, fAttr)
End Sub


'======================================================================================================
Private Sub btnGetFolder_Click

	Dim pc As DirectoryChooser
	pc.Initialize
	pathNameUndo = pathNameSel
	pc.InitialDirectory = pathNameSel

	pathNameSel = pc.Show(callingForm)
	textPath.Text = pathNameSel
	
	If enableDirSelEvent And xui.SubExists(mCallBack, mEventName & "_DirSelected", 0) Then
		CallSub2(mCallBack, mEventName & "_DirSelected", pathNameSel)
	End If

End Sub


'======================================================================================================
public Sub FileAttributes(f As String, fAttrArg As FileAttr_t)
	
	Dim fw As FileWatcher
	fw.Initialize("")
	Dim attrMap As Map
	attrMap.Initialize
	Dim textView As TextField
	Dim fullPath As String

	fAttrArg.creationDate		= -1
	fAttrArg.LastModifiedTime	= -1
	fAttrArg.LastAccessTime		= -1
	fAttrArg.size				= -1
	
	If f <> "" Then
		pathNameSel					= File.GetFileParent(f)
		fileNameSel 				= File.GetName(f)
		textFilename.Text 			= fileNameSel
		textPath.Text 	  			= pathNameSel
		fAttrArg.fileName			= fileNameSel
		fAttrArg.path				= pathNameSel
		
		Dim matcher1 As Matcher = Regex.Matcher("(\.?:)*([A-Za-z0-9]+)$$", fileNameSel)
		
		Do While matcher1.Find
			fAttrArg.FileExt = matcher1.Match
		Loop
		fullPath					= concatPathFilename(pathNameSel,fileNameSel)
		
		fAttrArg.size				= File.Size(pathNameSel, fileNameSel)
		fAttrArg.creationDate		= fw.GetCreationTime(fullPath)
		fAttrArg.LastModifiedTime	= fw.GetLastModifiedTime(fullPath)
		fAttrArg.LastAccessTime		= fw.GetLastAccessTime(fullPath)
		
		attrMap						= fw.CheckArbitraryAttribute(fullPath, "dos:readonly")
		fAttrArg.readOnly			= attrMap.GetValueAt(0)
		
		attrMap						= fw.CheckArbitraryAttribute(fullPath, "dos:system")
		fAttrArg.system				= attrMap.GetValueAt(0)

		attrMap						= fw.CheckArbitraryAttribute(fullPath, "dos:archive")
		fAttrArg.archived			= attrMap.GetValueAt(0)
		
		attrMap						= fw.CheckArbitraryAttribute(fullPath, "dos:hidden")
		fAttrArg.hidden				= attrMap.GetValueAt(0)
		
		fAttrArg.FileNotFound		= "n"
		
		fileDateStringFromFileAttr(fAttrArg, fAttrDatesAsStrings)
	
		addOrUpdateFile(fAttrArg, fAttrDatesAsStrings)
		
		'If the recent files table is open - update it otherwise don't bother
		If b4xTableRecent.mBase.Visible Then
			b4xTableRecent.SetData(getRecentList)
		End If
		
		textView = textFilename
		textView.TooltipText = fullPath
		
		textView = textPath
		textView.TooltipText = fullPath
	End If
	
	If enableFileSelEvent And xui.SubExists(mCallBack, mEventName & "_FileSelected", 0) Then
		CallSub2(mCallBack, mEventName & "_FileSelected", fAttrArg)
	End If
	
	If xui.SubExists(mCallBack, mEventName & "_FileSelectedInit", 0) Then
		CallSub2(mCallBack, mEventName & "_FileSelectedInit", fAttrArg)
	End If
End Sub


'======================================================================================================
public Sub fileDateTimeLongToStdDateTimeString(ticks As Long) As String
	DateTime.DateFormat = "yyyy-MM-dd"
	DateTime.TimeFormat = "HH:mm:ss"
	
	Return DateTime.Date(ticks) & " " & DateTime.Time(ticks)
End Sub


'======================================================================================================
public Sub fileDateStringFromFileAttr(fAttrArg As FileAttr_t, fAttrDatesAsStringsArg As FileDateStr_t)
	If fAttrArg.creationDate = -1 Then
		fAttrDatesAsStringsArg.creationDate = ""
	Else
		fAttrDatesAsStringsArg.creationDate 		= fileDateTimeLongToStdDateTimeString(fAttrArg.creationDate)
	End If

	If fAttrArg.LastModifiedTime = -1 Then
		fAttrDatesAsStringsArg.LastModifiedTime = ""
	Else
		fAttrDatesAsStringsArg.LastModifiedTime 	= fileDateTimeLongToStdDateTimeString(fAttrArg.LastModifiedTime)
	End If

	If fAttrArg.LastAccessTime = -1 Then
		fAttrDatesAsStringsArg.LastAccessTime = ""
	Else
		fAttrDatesAsStringsArg.LastAccessTime 	= fileDateTimeLongToStdDateTimeString(fAttrArg.LastAccessTime)
	End If
End Sub


'======================================================================================================
private Sub btnRecent_Filter(EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)
	
	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
					
			Case "ESCAPE"
				fileNameSel 		= fileNameUndo
				textFilename.Text 	= fileNameUndo
				pathNameSel			= pathNameUndo
				textPath.Text		= pathNameUndo
						
			Case "BACK_SPACE"
					
			Case "F12"
						
		End Select
	End If
End Sub


'======================================================================================================
private Sub btnGetFileName_Filter(EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)
	
	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
					
			Case "ESCAPE"
				fileNameSel 		= fileNameUndo
				textFilename.Text 	= fileNameUndo
				pathNameSel			= pathNameUndo
				textPath.Text		= pathNameUndo
						
			Case "BACK_SPACE"
					
			Case "F12"
						
		End Select
	End If
End Sub


'======================================================================================================
private Sub getFolder_Filter(EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)
	
	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
					
			Case "ESCAPE"
				fileNameSel 		= fileNameUndo
				textFilename.Text 	= fileNameUndo
				pathNameSel			= pathNameUndo
				textPath.Text		= pathNameUndo
						
			Case "BACK_SPACE"
					
			Case "F12"
						
		End Select
	End If
End Sub


'======================================================================================================
private Sub btnCpypath_Filter(EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)
	
	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
					
			Case "ESCAPE"
				fileNameSel 		= fileNameUndo
				textFilename.Text 	= fileNameUndo
				pathNameSel			= pathNameUndo
				textPath.Text		= pathNameUndo
						
			Case "BACK_SPACE"
					
			Case "F12"
						
		End Select
	End If
End Sub


'======================================================================================================
private Sub btnFileNameCpy_Filter(EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)
	
	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
					
			Case "ESCAPE"
				fileNameSel 		= fileNameUndo
				textFilename.Text 	= fileNameUndo
				pathNameSel			= pathNameUndo
				textPath.Text		= pathNameUndo
						
			Case "BACK_SPACE"
					
			Case "F12"
						
		End Select
	End If
End Sub


'======================================================================================================
Private Sub toastMsgShow(msgType As String, msg As String)
	
	Select msgType.ToLowerCase
		Case "warn", "warning"
			Toast.SetTMBackground(0xFF323232, 4, 0xFFFFE302, 4)
			Toast.SetTMTextProp(16, Toast.HPOS_CENTER, Toast.VPOS_CENTER, 0xFFFFE302)
		Case "info", "information"
			Toast.SetTMBackground(0xFF323232, 4, 0xFFFFFFFF, 4)
			Toast.SetTMTextProp(16, Toast.HPOS_CENTER, Toast.VPOS_CENTER, 0xFFFFFFFF)
		Case "crit", "critical"
			Toast.SetTMBackground(0xFF323232, 4, 0xFFFF1500, 4)
			Toast.SetTMTextProp(16, Toast.HPOS_CENTER, Toast.VPOS_CENTER, 0xFFFF1500)
		Case Else
			msg = "Illegal Message Type" & CRLF & msg
	End Select

	Toast.SetTMPosition(Toast.TMPOS_BOTTOM)
	Toast.SetTMDuration(2000, 3000)
	Toast.TMShow(msg, True, True)
End Sub


'======================================================================================================
public Sub setDisplayModeVal(displayModeArg As Int)
	displayMode = displayModeArg
	displayControl
End Sub


'======================================================================================================
public Sub getDisplayModeVal As Int
	Return displayMode
End Sub


'======================================================================================================
private Sub displayControl
	Select displayMode
		Case 0 'File Show only
			Pane1.Height = initPanelHeight / 2 + 2
			Pane1.Width  = initPanelWidth
			btnCpypath.Visible 		= False
			textPath.Visible	 	= False
			btnGetFolder.Visible	= False
			
		Case 1 'Show File and Path
			Pane1.Height = initPanelHeight
			Pane1.Width  = initPanelWidth
			btnCpypath.Visible 		= True
			textPath.Visible	 	= True
			btnGetFolder.Visible	= True
			
		Case 2 'Show File and recent
			Pane1.Height = 540
			Pane1.Width = 1.7 * initPanelWidth
			b4xTableRecent.mBase.Width = Pane1.Width - 16
			btnCpypath.Visible 		= False
			textPath.Visible	 	= False
			btnGetFolder.Visible	= False
			tblRecentDisplay
			b4xTableRecent.mBase.Visible  = True
			
		Case 3 'Show File, path and recent
			Pane1.Height = 540
			Pane1.Width = 1.7 * initPanelWidth
			b4xTableRecent.mBase.Width = Pane1.Width - 16
			btnCpypath.Visible 		= True
			textPath.Visible	 	= True
			btnGetFolder.Visible	= True
			tblRecentDisplay
			b4xTableRecent.mBase.Visible  = True
	End Select
End Sub


'======================================================================================================
private Sub btnPathExpose_Click
	If btnCpypath.Visible = False Then
		btnCpypath.Visible = True
		displayMode = Bit.Or(displayMode, 1)
	Else
		btnCpypath.Visible = False
		displayMode = Bit.And(displayMode, Bit.Not(1))
	End If

	displayControl
End Sub


'======================================================================================================
private Sub tblRecentDisplay
	b4xTableRecent.SetData(getRecentList)
		
	SetColumnAlignment("fName", 	"CENTER", "LEFT", 	b4xTableRecent)
	SetColumnAlignment("path", 		"CENTER", "LEFT", 	b4xTableRecent)
	SetColumnAlignment("ext", 		"CENTER", "CENTER", b4xTableRecent)
	SetColumnAlignment("la" , 		"CENTER", "CENTER", b4xTableRecent)
	SetColumnAlignment("cd" , 		"CENTER", "CENTER", b4xTableRecent)
	SetColumnAlignment("mod" , 		"CENTER", "CENTER", b4xTableRecent)
	SetColumnAlignment("size", 		"CENTER", "CENTER", b4xTableRecent)
	SetColumnAlignment("ro", 		"CENTER", "CENTER", b4xTableRecent)
	SetColumnAlignment("hidden", 	"CENTER", "CENTER", b4xTableRecent)
	SetColumnAlignment("system", 	"CENTER", "CENTER", b4xTableRecent)
	SetColumnAlignment("arch" , 	"CENTER", "CENTER", b4xTableRecent)
		
	SetColumnTextSize("fName", 	12, b4xTableRecent)
	SetColumnTextSize("path", 	12, b4xTableRecent)
	SetColumnTextSize("ext", 	12, b4xTableRecent)
	SetColumnTextSize("la", 	12, b4xTableRecent)
	SetColumnTextSize("cd", 	12, b4xTableRecent)
	SetColumnTextSize("mod", 	12, b4xTableRecent)
	SetColumnTextSize("size", 	12, b4xTableRecent)
	SetColumnTextSize("ro", 	12, b4xTableRecent)
	SetColumnTextSize("hidden", 12, b4xTableRecent)
	SetColumnTextSize("system", 12, b4xTableRecent)
	SetColumnTextSize("arch", 	12, b4xTableRecent)
	fillExtensionComboBox
End Sub


'======================================================================================================
private Sub btnRecent_Click
	'Init Width 600
	'InitHeight 78
	If b4xTableRecent.mBase.Visible Then
		displayMode = Bit.And(displayMode, Bit.Not(2))
		b4xTableRecent.mBase.Visible = False
	Else
		displayMode = Bit.Or(displayMode, 2)
		b4xTableRecent.mBase.Visible  = True
		tblRecentDisplay
	End If
	displayControl
End Sub


'======================================================================================================
private Sub textPath_Action
	
End Sub


'======================================================================================================
private Sub textPath_MouseClicked (EventData As MouseEvent)
	
End Sub


'======================================================================================================
private Sub textPath_FocusChanged (HasFocus As Boolean)
	
End Sub


'======================================================================================================
private Sub textFilename_Action
	

End Sub


'======================================================================================================
private Sub textFilename_TextChanged (Old As String, New As String)

End Sub


'======================================================================================================
private Sub textPath_TextChanged (Old As String, New As String)

End Sub


'======================================================================================================
private Sub textFilename_Filter (EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)

	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
				fileNameSel = textFilename.Text
				pathNameSel = textPath.Text
	
				If File.Exists(pathNameSel, fileNameSel) Then
					FileAttributes(pathNameSel & "\" & fileNameSel, fAttr)
				Else
					toastMsgShow("warn" , "File not found")
				End If
			
			Case "ESCAPE"
				textFilename.Text = fileNameUndo
				
			Case "BACK_SPACE"
				
			Case "F12"

				
		End Select
	End If
End Sub


'======================================================================================================
private Sub textPath_Filter(EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)
	
	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
				pathNameUndo = pathNameSel
				pathNameSel = textPath.Text
		
				If File.IsDirectory(pathNameSel,"") = False Then
					toastMsgShow("warn" , "Directory not found")
				End If
				
				If enableDirSelEvent And xui.SubExists(mCallBack, mEventName & "_DirSelected", 0) Then
					CallSub2(mCallBack, mEventName & "_DirSelected", pathNameSel)
				End If
				
			Case "ESCAPE"
				textFilename.Text = pathNameUndo
				If enableDirSelEvent And xui.SubExists(mCallBack, mEventName & "_DirSelected", 0) Then
					CallSub2(mCallBack, mEventName & "_DirSelected", pathNameSel)
				End If
					
			Case "BACK_SPACE"
				
			Case "F12"
					
		End Select
	End If
End Sub


'======================================================================================================
private Sub textFilename_MouseClicked (EventData As MouseEvent)
	
End Sub


'======================================================================================================
private Sub textFilename_FocusChanged (HasFocus As Boolean)
	
End Sub


'======================================================================================================
private Sub initRecentDatabase(path As String, dbName As String) As Boolean
	
	Dim qryStr As String
	Dim qryOutList As List
	Dim row() As String

	If File.Exists(path, dbName) Then
		Try
			sqlRecent.InitializeSQLite(path, dbName, False)
			'   				  logOn, setJournal, integrityCheck, doFullCheckPoint, closeAfterCheckpoint, setAutoCheckPoint) As Boolean
			If checkRecentFilesDB(sqlRecent, True,  "WAL",      True,           False, False,                5, path, dbName) = False Then
				Return False
			End If
		Catch
			Log(LastException)
			Return False
		End Try
	Else
		Try
			sqlRecent.InitializeSQLite(path, dbName, True)
		Catch
			Log(LastException)
			Return False
		End Try
		
		Try
			'Create the recent files table
			createRecentTable(sqlRecent)

			'   				  logOn, setJournal, integrityCheck, doFullCheckPoint, closeAfterCheckpoint, setAutoCheckPoint) As Boolean
			If checkRecentFilesDB(sqlRecent, True,  "WAL",      False,          False, False,   			 5, path, dbName) = False Then
				Return False
			End If
		Catch
			Log(LastException)
			Return False
		End Try
	End If
	
	' Get the newest File entry from the recent files list
	qryStr = "select ID, path, fileName from tblRecentFiles order by ID desc limit 1;"
	qryOutList = ExecuteMemoryTable(sqlRecent, qryStr, Null, 1)
		
	If qryOutList.Size = 0 Then
		' Blank the fields
		textFilename.Text = ""
		textPath.Text = ""
		fileNameSel = ""
		pathNameSel =""
		Return True
	Else
		' Populate with most recent filenam and pathname
		row = qryOutList.Get(0)
		fileNameSel = row(2)
		pathNameSel = row(1)
		textFilename.Text = fileNameSel
		textPath.Text     = pathNameSel
		FileAttributes(pathNameSel & "\" & fileNameSel, fAttr)
	End If
	
	Return True
End Sub


'======================================================================================================
Public Sub RemoveRedundantSpace(TextToClean As String) As String
	Return Regex.Replace("[\s]{2,}", TextToClean, " ")
End Sub


'======================================================================================================
Public Sub checkRecentFilesDB(dbArg As SQL, logOn As Boolean, setJournal As String, _
							  integrityCheck As Boolean, doFullCheckPoint As Boolean, _
							  closeAfterCheckPoint As Boolean, _
							  setAutoCheckPoint As Int, path As String, dbName As String _
							  ) As Boolean
	'Check the database
	Dim qryStr As String
	Dim qryOutList As List
	Dim row() As String
	
	If integrityCheck Then
		qryStr = "PRAGMA integrity_check;"
		qryOutList = ExecuteMemoryTable(dbArg, qryStr, Null, 2)
		row = qryOutList.Get(0)
		If row(0).CompareTo("ok") <> 0 Then
			If logOn Then Log("DB Integrity = BAD")
			Return False
		End If
	
		If logOn Then Log("DB Integrity = OK")
	End If
	
	
	If setJournal <> "" Then
		qryStr = "PRAGMA journal_mode=" &  setJournal & ";"
		qryOutList = ExecuteMemoryTable(dbArg, qryStr, Null, 2)
		row = qryOutList.Get(0)
		If row(0).CompareTo("wal") <> 0 Then
			If logOn Then Log("Set Journal Mode = " &  setJournal & " Mode = FAILED")
			Return False
		End If
		
		If logOn Then Log("Set Journal Mode = " &  setJournal & " Mode = OK")
	End If
	
	
	If doFullCheckPoint Then
		dbArg.Close
		dbArg.InitializeSQLite(path, dbName, False)

		qryStr = "PRAGMA wal_checkpoint(TRUNCATE);"
		Try
			dbArg.ExecNonQuery(qryStr)
		Catch
			Log(LastException)
			If logOn Then Log("Checkpoint TRUNCATE = Failed")
			Return False
		End Try

		If logOn Then Log("Checkpoint TRUNCATE = OK")
		If closeAfterCheckPoint = True Then
			dbArg.Close
		End If
	End If

	If setAutoCheckPoint <> -3 Then
		Select setAutoCheckPoint
			Case -1
				qryStr = "PRAGMA wal_autocheckpoint=-1;" 	'No checkpoint
			Case 0
				qryStr = "PRAGMA wal_autocheckpoint=1000;"  'sqLite Default
			Case Else
				qryStr = "PRAGMA wal_autocheckpoint=" & setAutoCheckPoint & ";" 'User setting
		End Select
			
		qryOutList = ExecuteMemoryTable(dbArg, qryStr, Null, 2)
		row = qryOutList.Get(0)
		If row(0) < 0 Then
			If logOn Then Log("DB Checkpoint Value Setting = Failed")
			Return False
		End If
		
		If logOn Then Log("DB Checkpoint Value Setting = OK")
	End If
	Return True
End Sub


'======================================================================================================
Public Sub dbRecentCloseAndCheckpoint
	'   				  			 logOn, setJournal, integrityCheck, doFullCheckPoint, closeAfterCheckpoint, setAutoCheckPoint) As Boolean
	If checkRecentFilesDB(sqlRecent, True,  "",         True,           True,             True,                 -3, dataDir, dbRecentFilename) = False Then
		'TODO
	End If
End Sub


'======================================================================================================
'Executes the query and returns the result as a list of arrays.
'Each item in the list is a strings array.
'StringArgs - Values to replace question marks in the query. Pass Null if not needed.
'Limit - Limits the results. Pass 0 for all results.
Public Sub ExecuteMemoryTable(SQL As SQL, Query As String, StringArgs() As String, Limit As Int) As List
	Dim cur As ResultSet

	If StringArgs = Null Then
		Dim StringArgs(0) As String
	End If
	
	Try
		cur = SQL.ExecQuery2(Query, StringArgs)
	Catch
		Log(LastException)
		Return Null
	End Try
	
'	Log("ExecuteMemoryTable: " & Query)
	Dim table As List
	table.Initialize
	
	Try
		Do While cur.NextRow
			Dim values(cur.ColumnCount) As String
			For col = 0 To cur.ColumnCount - 1
				values(col) = cur.GetString2(col)
			Next
			table.Add(values)
			If Limit > 0 And table.Size >= Limit Then Exit
		Loop
	Catch
		Log(LastException)
		Return Null
	End Try

	cur.Close
	Return table
End Sub


'======================================================================================================
Private Sub createRecentTable(db As SQL)
	Dim qryStr As String

	' Create the main Table
	qryStr = _
	$"CREATE TABLE tblRecentFiles(
  		ID INTEGER, 
  		fileName TEXT, 
  		path TEXT, 
  		fullPath TEXT, 
  		dateFirstSelected DATETIME, 
  		dateLastSelected DATETIME, 
        dateCreated DATETIME,
        dateLastModified DATETIME,
        dateLastAccessed DATETIME,
  		fileNotFound CHAR, 
  		fileSize LARGEINT, 
		readOnly BOOLEAN,
		hidden BOOLEAN,
		archive  BOOLEAN,
		system BOOLEAN,
		ext STRING,
  	CONSTRAINT ID PRIMARY KEY(ID COLLATE BINARY))"$
	
	Try
		db.ExecNonQuery(qryStr)
	Catch
		Log(LastException)
		Return
	End Try

	qryStr = _
	$"CREATE UNIQUE INDEX fullPath ON tblRecentFiles (fullPath ASC );"$
	
	Try
		db.ExecNonQuery(qryStr)
	Catch
		Log(LastException)
		Return
	End Try

	' Create the extension index
	qryStr = _
	$"CREATE INDEX indxExt ON tblRecentFiles (ext);"$
	
	Try
		db.ExecNonQuery(qryStr)
	Catch
		Log(LastException)
		Return
	End Try
	
	' Create the filename index
	qryStr = _
	$"CREATE INDEX indxFileName ON tblRecentFiles (fileName);"$
	
	Try
		db.ExecNonQuery(qryStr)
	Catch
		Log(LastException)
		Return
	End Try
End Sub


'======================================================================================================
Private Sub addOrUpdateFile(fat As FileAttr_t, fatD As FileDateStr_t) As Boolean
	'Check if full path exists
	Dim qryStr As String
	Dim dateStr As String
	DateTime.DateFormat = "yyyy-MM-dd"
	DateTime.TimeFormat = "HH:mm:ss"
	dateStr = DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now)
	
	Dim fullPath As String = fat.path & "\" & fat.fileName

	qryStr = _
	$"SELECT COUNT(fullPath) FROM tblRecentFiles WHERE fullPath = ?"$
	
	Dim cur As ResultSet
	
'	sqlRecent.BeginTransaction
	Try
		cur = sqlRecent.ExecQuery2(qryStr, Array As String(fullPath))
	Catch
		Log(LastException)
	End Try
'	sqlRecent.TransactionSuccessful
	
	cur.NextRow
	If cur.GetLong2(0) = 0 Then
		qryStr = _
				$"INSERT INTO tblRecentFiles (
                  fileName,
                  path,
				  fullPath,
                  dateFirstSelected,
                  dateLastSelected,
				  dateCreated,
        		  dateLastModified,
        		  dateLastAccessed,
				  fileNotFound,
				  fileSize,
				  readOnly,
				  hidden,
				  archive,
				  system,
				  ext
				  )
                  VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"$
						  
		qryStr = RemoveRedundantSpace(qryStr)
		
		sqlRecent.BeginTransaction
		Try
			sqlRecent.ExecNonQuery2(qryStr, Array As String(fat.fileName, fat.path, fullPath, _
									dateStr, dateStr, fatD.creationDate, fatD.LastModifiedTime, fatD.LastAccessTime, _
									fat.FileNotFound, fat.size, fat.readOnly, fat.hidden, fat.archived, fat.system, fat.FileExt))
			
			Log("Recent File Added: " & fullPath &  "  Date: " & dateStr)
		Catch
			Log(LastException)
		End Try
		sqlRecent.TransactionSuccessful
		
	Else
		qryStr = _
				$"UPDATE tblRecentFiles 
					SET 
						dateLastSelected	= ?, 
						dateCreated			= ?, 
        		  		dateLastModified	= ?, 
        		  		dateLastAccessed	= ?, 
				  		fileNotFound		= ?, 
				  		fileSize			= ?, 
				  		readOnly			= ?, 
				  		hidden				= ?, 
				  		archive				= ?, 
				  		system				= ?,
						ext					= ?	 
					WHERE fullPath 			= ?"$
	
		qryStr = RemoveRedundantSpace(qryStr)
		
		sqlRecent.BeginTransaction
		Try
			sqlRecent.ExecNonQuery2(qryStr, Array As String(dateStr, fatD.creationDate, fatD.LastModifiedTime, fatD.LastAccessTime, _
									fat.FileNotFound, fat.size, fat.readOnly, fat.hidden, fat.archived, fat.system, fat.FileExt, fullPath))
			Log("Recent File Updated: " & fullPath &  "  Date: " & dateStr)
		Catch
			Log(LastException)
		End Try
		sqlRecent.TransactionSuccessful
		
	End If
	Return True
End Sub


'======================================================================================================
private Sub getRecentList As List

	Dim qryStr As String

	If chkBoxShowAll.Checked Then
		qryStr = $"
			Select fileName,
			path,
			ext,
			dateLastAccessed,
			dateCreated,
			dateLastModified,
			fileSize,
			readOnly,
			hidden,
			system,
			archive
			FROM tblRecentFiles
			ORDER BY dateLastAccessed DESC"$
	
		qryStr = RemoveRedundantSpace(qryStr)
		Return ExecuteMemoryTable(sqlRecent, qryStr, Null, 0)
		
	Else
		qryStr = $"
			Select fileName,
			path,
			ext,
			dateLastAccessed,
			dateCreated,
			dateLastModified,
			fileSize,
			readOnly,
			hidden,
			system,
			archive
			FROM tblRecentFiles
			WHERE ext = ?
			ORDER BY dateLastAccessed DESC"$
	
		qryStr = RemoveRedundantSpace(qryStr)
		Return ExecuteMemoryTable(sqlRecent, qryStr, Array As String(comboFileTypeExt.SelectedItem), 0)
	End If
End Sub


'======================================================================================================
private Sub getFileExtensionList As List

	Dim qryStr As String

	qryStr = $"SELECT ext
			   FROM tblRecentFiles 
			   GROUP BY ext 
			   ORDER BY ext"$
		
	qryStr = RemoveRedundantSpace(qryStr)
	Return ExecuteMemoryTable(sqlRecent, qryStr, Null, 0)
End Sub


'======================================================================================================
private Sub fillExtensionComboBox
	Dim lst As List
	lst.Initialize
	Dim lst2 As List
	lst2.Initialize
	
	lst = getFileExtensionList
	
	For Each row() As Object In lst
		lst2.Add(row(0))
	Next
	comboFileTypeExt.SetItems(lst2)
End Sub


'======================================================================================================
Sub initRecentFilesTable
	b4xTableRecent.RowHeight = 18dip
	b4xTableRecent.NumberOfFrozenColumns = 1
	Dim tblMainB4x_Cols As mainTableProduceColumn_t
	tblMainB4x_Cols.Initialize
	Dim cw As Int 'Column width

	tblMainB4x_Cols.col_fileName.DisableAutoResizeLayout = True
	tblMainB4x_Cols.col_fileName =  b4xTableRecent.AddColumn(" Filename", b4xTableRecent.COLUMN_TYPE_TEXT)
	tblMainB4x_Cols.col_fileName.Id = "fName"
	tblMainB4x_Cols.col_fileName.Width = 200dip
	tblMainB4x_Cols.col_fileName.Searchable = True
	
	tblMainB4x_Cols.col_pathName.DisableAutoResizeLayout = True
	tblMainB4x_Cols.col_pathName =  b4xTableRecent.AddColumn(" Path", b4xTableRecent.COLUMN_TYPE_TEXT)
	tblMainB4x_Cols.col_pathName.Id = "path"
	tblMainB4x_Cols.col_pathName.Width = 220dip
	tblMainB4x_Cols.col_pathName.Searchable = True
	
	tblMainB4x_Cols.col_ext.DisableAutoResizeLayout = True
	tblMainB4x_Cols.col_ext =  b4xTableRecent.AddColumn(" Ext", b4xTableRecent.COLUMN_TYPE_TEXT)
	tblMainB4x_Cols.col_ext.Id = "ext"
	tblMainB4x_Cols.col_ext.Width = 40dip
	tblMainB4x_Cols.col_ext.Searchable = False
	
	cw = 120dip
	
	tblMainB4x_Cols.dateLastAccessed.DisableAutoResizeLayout = True
	tblMainB4x_Cols.dateLastAccessed  = b4xTableRecent.AddColumn(" Last Accessed", b4xTableRecent.COLUMN_TYPE_TEXT)
	tblMainB4x_Cols.dateLastAccessed.Id = "la"
	tblMainB4x_Cols.dateLastAccessed.Width = cw
	tblMainB4x_Cols.dateLastAccessed.Searchable = False
	

	tblMainB4x_Cols.dateCreated.DisableAutoResizeLayout = True
	tblMainB4x_Cols.dateCreated  = b4xTableRecent.AddColumn(" Created", b4xTableRecent.COLUMN_TYPE_TEXT)
	tblMainB4x_Cols.dateCreated.Id = "cd"
	tblMainB4x_Cols.dateCreated.Width = cw
	tblMainB4x_Cols.dateCreated.Searchable = False

	tblMainB4x_Cols.dateLastModified.DisableAutoResizeLayout = True
	tblMainB4x_Cols.dateLastModified  = b4xTableRecent.AddColumn(" Modified", b4xTableRecent.COLUMN_TYPE_TEXT)
	tblMainB4x_Cols.dateLastModified.Id = "mod"
	tblMainB4x_Cols.dateLastModified.Width = cw
	tblMainB4x_Cols.dateLastModified.Searchable = False
	
	cw = 80
	
	tblMainB4x_Cols.fileSize.DisableAutoResizeLayout = True
	tblMainB4x_Cols.fileSize =  b4xTableRecent.AddColumn("Size", b4xTableRecent.COLUMN_TYPE_NUMBERS)
	tblMainB4x_Cols.fileSize.Id = "size"
	tblMainB4x_Cols.fileSize.Width = cw
	tblMainB4x_Cols.fileSize.Searchable = False

	cw = 36dip
	
	tblMainB4x_Cols.readOnly.DisableAutoResizeLayout = True
	tblMainB4x_Cols.readOnly  = b4xTableRecent.AddColumn("R", b4xTableRecent.COLUMN_TYPE_TEXT)
	tblMainB4x_Cols.readOnly.Id = "ro"
	tblMainB4x_Cols.readOnly.Width = cw
	tblMainB4x_Cols.readOnly.Searchable = False

	tblMainB4x_Cols.hidden.DisableAutoResizeLayout = True
	tblMainB4x_Cols.hidden  = b4xTableRecent.AddColumn("H", b4xTableRecent.COLUMN_TYPE_TEXT)
	tblMainB4x_Cols.hidden.Id = "hidden"
	tblMainB4x_Cols.hidden.Width = cw
	tblMainB4x_Cols.hidden.Searchable = False
	
	tblMainB4x_Cols.system.DisableAutoResizeLayout = True
	tblMainB4x_Cols.system  = b4xTableRecent.AddColumn("S", b4xTableRecent.COLUMN_TYPE_TEXT)
	tblMainB4x_Cols.system.Id = "system"
	tblMainB4x_Cols.system.Width = cw
	tblMainB4x_Cols.system.Searchable = False
	
	tblMainB4x_Cols.archive.DisableAutoResizeLayout = True
	tblMainB4x_Cols.archive  = b4xTableRecent.AddColumn("A", b4xTableRecent.COLUMN_TYPE_TEXT)
	tblMainB4x_Cols.archive.Id = "arch"
	tblMainB4x_Cols.archive.Width = cw
	tblMainB4x_Cols.archive.Searchable = False

	b4xTableRecent.MaximumRowsPerPage = 30
	b4xTableRecent.BuildLayoutsCache(b4xTableRecent.MaximumRowsPerPage)

	'Set search parameters
	b4xTableRecent.HighlightSearchResults = True
End Sub



'======================================================================================================
Sub SetColumnAlignment(columnID As String, alignmentV As String, alignmentH As String, tblViewB4X As B4XTable)
	Dim column As B4XTableColumn = tblViewB4X.GetColumn(columnID)
	For i = 0 To column.CellsLayouts.Size - 1        'starts at 1 due to header
		Dim pnl As B4XView = column.CellsLayouts.Get(i)
		pnl.GetView(0).SetTextAlignment(alignmentV, alignmentH)
	Next
End Sub


'======================================================================================================
Sub SetColumnTextSize(columnID As String, textSize As Int, tblViewB4X As B4XTable)
	Dim column As B4XTableColumn = tblViewB4X.GetColumn(columnID)
	For i = 0 To column.CellsLayouts.Size - 1        'starts at 1 due to header
		Dim pnl As B4XView = column.CellsLayouts.Get(i)
		pnl.GetView(0).TextSize = textSize
	Next
End Sub
'======================================================================================================


'************************** Author:  stevel05 *********************************************************
'https://www.b4x.com/android/forum/threads/file-chooser-utils.92092/#content

'Adds the specified file extenstions.
'There must be the same number of Descriptions as Filters.
Public Sub AddExtensionFilters(FC As FileChooser, Descriptions As List, Filters As List)
	AddExtensionFilters4(FC,Descriptions, Filters, False,"", False)
End Sub


'======================================================================================================
'Adds the specified file extenstions and optional merged item.
'There must be the same number of Descriptions as Filters.
Public Sub AddExtensionFilters2(FC As FileChooser, Descriptions As List, Filters As List, MergeName As String)
	AddExtensionFilters4(FC,Descriptions, Filters, True, MergeName, False)
End Sub


'======================================================================================================
'Adds the specified file extenstions and optional AllFIles item.
'There must be the same number of Descriptions as Filters.
Public Sub AddExtensionFilters3(FC As FileChooser, Descriptions As List, Filters As List, AllFiles As Boolean)
	AddExtensionFilters4(FC,Descriptions, Filters, False, "", AllFiles)
End Sub


'======================================================================================================
'Adds the specified file extenstions and optional merged item and optional All Files item.
'There must be the same number of Descriptions as Filters.
Public Sub AddExtensionFilters4(FC As FileChooser, Descriptions As List, Filters As List, Merge As Boolean, MergeName As String, AllFiles As Boolean)
	If Descriptions.Size <> Filters.Size Then
		Log("Extension filters not added")
		Return
	End If
	Dim ExtFilters As List
	ExtFilters.Initialize

	If AllFiles Then
		Dim ExtensionFilter As JavaObject
		ExtensionFilter.InitializeNewInstance("javafx.stage.FileChooser.ExtensionFilter",Array("All Files",Array As String("*.*")))
		ExtFilters.add(ExtensionFilter)
	End If

	If Merge Then
		Dim ExtensionFilter As JavaObject
		ExtensionFilter.InitializeNewInstance("javafx.stage.FileChooser.ExtensionFilter",Array(MergeName,Filters))
		ExtFilters.add(ExtensionFilter)
	End If

	For i = 0 To Filters.Size - 1
		Dim ExtensionFilter As JavaObject
		ExtensionFilter.InitializeNewInstance("javafx.stage.FileChooser.ExtensionFilter",Array(Descriptions.Get(i),Array As String(Filters.Get(i))))
		ExtFilters.add(ExtensionFilter)
	Next
	Dim FCJO As JavaObject = FC
	Dim EFs As List = FCJO.RunMethod("getExtensionFilters",Null)
	EFs.AddAll(ExtFilters)
End Sub


'======================================================================================================
'Pass the Description to specify the initially selected file extension.  
'Pass the MergeName or 'All Files' if you use these options and want either to be preselected
Public Sub SetSelectedExtensionFilter(FC As FileChooser, Description As String)
	Dim FCJO As JavaObject = FC
	Dim EFs As List = FCJO.RunMethod("getExtensionFilters",Null)
	For Each EF As JavaObject In EFs
		If EF.RunMethod("getDescription",Null) = Description Then
			FCJO.RunMethod("setSelectedExtensionFilter",Array(EF))
			Exit
		End If
	Next
End Sub


'======================================================================================================
Sub b4xTableRecent_CellClicked (ColumnId As String, RowId As Long)

	Dim fileName As String
	Dim pathName As String
	Dim row As Map
	
	Dim row As Map = b4xTableRecent.GetRow(RowId)
	
	fileName = row.Get("fName")
	pathName = row.Get("path")
	
	fileNameUndo = textFilename.Text
	pathNameUndo = textPath.Text
	
	If File.Exists(pathName, fileName) Then
		'Update the last selected time & found flag
		FileAttributes(pathName & "\" & fileName, fAttr)
		textFilename.text = fAttr.fileName
		textPath.Text 	  = fAttr.path
		
	Else
		'Update the not found flag and selected time
		toastMsgShow("warn", "File has not been found")
		'TODO dialog with option to exclude or not
	End If
	b4xTableRecent.SetData(getRecentList)
End Sub


'======================================================================================================
Sub b4xTableRecent_CellLongClicked (ColumnId As String, RowId As Long)
	
End Sub


'======================================================================================================
Sub b4xTableRecent_DataUpdated
	
End Sub


'======================================================================================================
Sub b4xTableRecent_HeaderClicked (ColumnId As String)
	
End Sub


'======================================================================================================
Sub b4xTableRecent_HeaderLongClicked (ColumnId As String)
	
End Sub


'======================================================================================================
Sub comboFileTypeExt_SelectedIndexChanged (Index As Int)
	b4xTableRecent.SetData(getRecentList)
End Sub


'======================================================================================================
Sub chkBoxShowAll_CheckedChange(Checked As Boolean)
	If Checked = True Then
		comboFileTypeExt.mBase.Enabled = False
	Else
		comboFileTypeExt.mBase.Enabled = True
	End If
	b4xTableRecent.SetData(getRecentList)
End Sub


'======================================================================================================
Sub exportToSqLite_Click
	Dim fc As FileChooser
	fc.Initialize

	Dim dlg As B4XDialog
	dlg.Initialize(callingForm.RootPane)
	
	Dim choiceDlg As B4XListTemplate
	choiceDlg.Initialize
	choiceDlg.Options = Array("Overwrite", "Append", "Cancel")
	choiceDlg.AllowMultiSelection = False
	choiceDlg.MultiSelectionMinimum = 1
	choiceDlg.CustomListView1.DefaultTextBackgroundColor = 0xFFFFFFFF
	choiceDlg.CustomListView1.DefaultTextColor = 0xFF000000
	
	dlg.Title = "Export File List To sqLite DB"
	dlg.BorderCornersRadius = 5
	dlg.BorderWidth = 2
	dlg.OverlayColor = 0x95DEDEDE
	dlg.BlurBackground = True
	dlg.BodyTextColor = 0xFF000000
	dlg.TitleBarColor = 0xFF000000
	dlg.TitleBarTextColor = 0xFFFFFFFF

	SetSelectedExtensionFilter(fc,"sqLite Database Files")
	
	fc.Title = "Save Recent Files List to sqLite Database"
	fc.SetExtensionFilter("sqLite DB", Array As String("*.db", "*.sqLite", "*.sqLite3"))
	
	Dim f As String = fc.ShowSave(callingForm)

	Dim pathNameExp As String = File.GetFileParent(f)
	Dim fileNameExp As String = File.GetName(f)
	
	If File.Exists(pathNameExp, fileNameExp) Then
		Wait For (dlg.ShowTemplate(choiceDlg,"", "", "")) Complete (Result As Int)

		Select choiceDlg.SelectedItem.ToLowerCase
			Case "overwrite"
				'Delete the existing file
				File.Delete(pathNameExp, fileNameExp)
				
				'Create the new database and create the files list table
				createNewExport(pathNameExp, fileNameExp)
				transferData(pathNameExp, fileNameExp)
				
			Case "append"
				transferData(pathNameExp, fileNameExp)
				
			Case "cancel"
		End Select
								
	Else
		'Create the new database and create the files list table
		createNewExport(pathNameExp, fileNameExp)
		transferData(pathNameExp, fileNameExp)
	End If
End Sub


'======================================================================================================
Private Sub createNewExport(pathArg As String, fileArg As String)
	Dim exportSQL As SQL
	
	'Create the new database and create the files list table
	exportSQL.InitializeSQLite(pathArg, fileArg, True)
	createRecentTable(exportSQL)
	'   				  			 logOn, setJournal, integrityCheck, doFullCheckPoint, closeAfterCheckpoint, setAutoCheckPoint) As Boolean
	If checkRecentFilesDB(exportSQL, True,  "WAL",      True,           False,            False,  				5, Null, Null) = False Then
		'TODO
	End If
End Sub


'======================================================================================================
Private Sub transferData(pathArg As String, fileArg As String)
	Dim sqlStr As String
	Dim fullPath As String
	
	'Attach the new db to the main recentDiles db to facilitate data transfer
	fullPath = concatPathFilename(pathArg, fileArg)
	sqlStr = "ATTACH DATABASE " & "'" & fullPath & "'" & " AS ExportDB;"
	sqlRecent.ExecNonQuery(sqlStr)

	If chkBoxShowAll.Checked Then
		'Insert records into the export DB table
		sqlStr = _
			$"INSERT OR REPLACE INTO ExportDB.tblRecentFiles 
			  SELECT tblRecentFiles.* 
			  FROM main.tblRecentFiles"$
		  
		sqlStr = RemoveRedundantSpace(sqlStr)
		sqlRecent.AddNonQueryToBatch(sqlStr, Null)
	Else
		'Inser records filtered by extension
		sqlStr = _
			$"INSERT OR REPLACE INTO ExportDB.tblRecentFiles
			  SELECT tblRecentFiles.* 
			  FROM main.tblRecentFiles 
			  WHERE ext = ?"$		
		sqlStr = RemoveRedundantSpace(sqlStr)
		sqlRecent.AddNonQueryToBatch(sqlStr, Array As String(comboFileTypeExt.SelectedItem))
	End If

	Dim SenderFilter As Object = sqlRecent.ExecNonQueryBatch("SQL")
	Wait for (SenderFilter) SQL_NonQueryComplete (Success As Boolean)
	Log("NonQuery: " & Success)
End Sub


'======================================================================================================
Sub btnExportRecentList_Click
	Dim fc As FileChooser
	fc.Initialize

	Dim dlg As B4XDialog
	dlg.Initialize(callingForm.RootPane)
	
	Dim choiceDlg As B4XListTemplate
	choiceDlg.Initialize
	choiceDlg.Options = Array("Overwrite", "Cancel")
	choiceDlg.AllowMultiSelection = False
	choiceDlg.MultiSelectionMinimum = 1
	choiceDlg.CustomListView1.DefaultTextBackgroundColor = 0xFFFFFFFF
	choiceDlg.CustomListView1.DefaultTextColor = 0xFF000000
	
	dlg.Title = "Export File List to CSV"
	dlg.BorderCornersRadius = 5
	dlg.BorderWidth = 2
	dlg.OverlayColor = 0x95DEDEDE
	dlg.BlurBackground = True
	dlg.BodyTextColor = 0xFF000000
	dlg.TitleBarColor = 0xFF000000
	dlg.TitleBarTextColor = 0xFFFFFFFF

	SetSelectedExtensionFilter(fc,"sqLite Database Files")
	
	fc.Title = "Save Recent Files List CSV"
	fc.SetExtensionFilter("CSV Files", Array As String("*.csv", "*.txt"))
	
	Dim f As String = fc.ShowSave(callingForm)

	Dim pathNameExp As String = File.GetFileParent(f)
	Dim fileNameExp As String = File.GetName(f)
	
	If File.Exists(pathNameExp, fileNameExp) Then
		Wait For (dlg.ShowTemplate(choiceDlg,"", "", "")) Complete (Result As Int)

		Select choiceDlg.SelectedItem.ToLowerCase
			Case "overwrite"
				'Delete the existing file
				File.Delete(pathNameExp, fileNameExp)
				
				'Create the new database and create the files list table
				ExportDatabaseToCSV(pathNameExp, fileNameExp)
				
			Case "cancel"
		End Select
	Else
		'Create the new database and create the files list table
		ExportDatabaseToCSV(pathNameExp, fileNameExp)
	End If
End Sub


'======================================================================================================
Public Sub ExportDatabaseToCSV(pathArg As String, pfileArg As String)

	Dim data As List
	Dim sqlStr As String
	data.Initialize
	Dim headers As List
	headers.Initialize
	Dim tblSchema As List
	tblSchema.Initialize
	
	If chkBoxShowAll.Checked Then
		'Get all records
		sqlStr = _
			$"SELECT tblRecentFiles.* 
			  FROM tblRecentFiles"$
		  
		sqlStr = RemoveRedundantSpace(sqlStr)
		data = ExecuteMemoryTable(sqlRecent, sqlStr, Null, 0)
	Else
		'Get records filtered by extension
		sqlStr = _
			$"SELECT tblRecentFiles.* 
			  FROM tblRecentFiles 
			  WHERE ext = ?"$		
		sqlStr = RemoveRedundantSpace(sqlStr)
		data = ExecuteMemoryTable(sqlRecent, sqlStr, Array As String(comboFileTypeExt.SelectedItem), 0)
	End If
	
	' Now get the field (column) names for use as headers)
	sqlStr = $"PRAGMA table_info(tblRecentFiles);"$
	tblSchema = ExecuteMemoryTable(sqlRecent, sqlStr, Null, 0)
	
	Dim row() As Object
	
	For i = 0 To tblSchema.Size - 1
		row = tblSchema.Get(i)
		headers.Add(row(1))
	Next

	Dim su As StringUtils
	su.SaveCSV2(pathArg, pfileArg, ",", data, headers)
End Sub


'======================================================================================================
Sub renameTo(Folder As String, FileName As String, NewFileName As String) As Object
	Dim fileJO As JavaObject
	fileJO.InitializeNewInstance("java.io.File", Array(File.Combine(Folder, FileName)))

	Dim newFileJO As JavaObject
	newFileJO.InitializeNewInstance("java.io.File", Array(File.Combine(Folder, NewFileName)))
	
	Return fileJO.RunMethod("renameTo", Array(newFileJO))
End Sub


'======================================================================================================
Sub btnClearRecentList_Click
	DateTime.DateFormat = "yyyy_MM_dd"
	DateTime.TimeFormat = "HH_mm_ss"
	Dim backupFileName As String
	Dim fileExt As String
	Dim fileNameStripped As String
	
	Dim matcher1 As Matcher = Regex.Matcher("(\.?:)*([A-Za-z0-9]+)$$", dbRecentFilename)
		
	Do While matcher1.Find
		fileExt = matcher1.Match
	Loop
	
	'   				  			 logOn, setJournal, integrityCheck, doFullCheckPoint, closeAfterCheckpoint, setAutoCheckPoint) As Boolean
	If checkRecentFilesDB(sqlRecent, True,  "",         False,           True,             True,                 -3, dataDir, dbRecentFilename) = False Then
		toastMsgShow("info", "Clear failed - Could not checkpoint recent files database")
		Return
	End If
	
	fileNameStripped = Regex.Replace("\." & fileExt, dbRecentFilename, "")
	
	backupFileName = fileNameStripped & "_" & DateTime.Date(DateTime.Now) & "_" & DateTime.Time(DateTime.Now) & ".db"


	If renameTo(dataDir, dbRecentFilename, backupFileName) = False Then
		toastMsgShow("info", "Clear failed - Backup could not be created")
		Return
	End If
	

	'Create a new recent files db with no entries in its tblRecentFiles
	initRecentDatabase(dataDir, dbRecentFilename)
	b4xTableRecent.SetData(getRecentList)
	
	toastMsgShow("info", "Recent files cleared" & CRLF & "Backup created " & dbRecentFilename & "_" & DateTime.Date(DateTime.Now) & "_" & DateTime.Time(DateTime.Now))
End Sub